#include <stdio.h>
#include "opencv2/opencv.hpp"

#define PIXVAL(iplimagep, x, y) (*(uchar *)((iplimagep)->imageData + (y) * (iplimagep)->widthStep + (x)))

int
main()
{
    int i, j;
    int m0, mx, my;

    CvCapture *capture = cvCaptureFromCAM(0);

    IplImage *frame, *img, *bin, *result;

    if (capture == NULL) {
        fprintf(stderr, "cannot capture\n");
        return 1;
    }

    frame = cvQueryFrame(capture);
    img = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
    bin = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
    result = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 3); // color

    cvNamedWindow("input", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("binary", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("result", CV_WINDOW_AUTOSIZE);

    while (1) {
        frame = cvQueryFrame(capture); /* cannot be modified */
        cvCvtColor(frame, img, CV_BGR2GRAY);

        m0 = 0;
        mx = 0;
        my = 0;

        for (j = 0; j < img->height; j++) {
            for (i = 0; i < img->width; i++) {
                if (PIXVAL(img, i, j) > 128) {
                    PIXVAL(bin, i, j) = 255;
                    m0++;
                    mx += i;
                    my += j;
                } else {
                    PIXVAL(bin, i, j) = 0;
                }
            }
        }

        cvCvtColor(bin, result, CV_GRAY2BGR);

        if (m0 > 0) {
            int gx = mx / m0; 
            int gy = my / m0; 
            cvLine(result, cvPoint(gx, 0), cvPoint(gx, img->height - 1), CV_RGB(255, 0, 0));
            cvLine(result, cvPoint(0, gy), cvPoint(img->width - 1, gy), CV_RGB(255, 0, 0));
        }

        cvShowImage("input", img);
        cvShowImage("binary", bin);
        cvShowImage("result", result);

        if (cvWaitKey(30) > 0) {
            break;
        }
    }
    return 0;
}
